diff -ruN uppsrc/ide/LayDes/laydes.cpp uppsrc/ide/LayDes/laydes.cpp
--- uppsrc/ide/LayDes/laydes.cpp	2013-05-25 23:14:35 +0400
+++ uppsrc/ide/LayDes/laydes.cpp	2013-08-20 02:14:36 +0400
@@ -1252,6 +1252,38 @@
 	ReloadItems();
 }
 
+bool RectLess(const Rect& a, const Rect& b)
+{
+	if(a.top < b.top)
+		return true;
+	if(a.top == b.top)
+		return a.left < b.left;
+	return false;
+}
+
+void LayDes::SortItems()
+{
+	SaveState();
+	if(currentlayout < 0)
+		return;
+	LayoutData& l = CurrentLayout();
+	int count = l.item.GetCount();
+	Vector<Rect> rect;
+	rect.SetCount(count);
+	for(int i = 0; i < count; ++i)
+		rect[i] = CtrlRect(l.item[i].pos, l.size);
+	Vector<int> order;
+	order.SetCount(count);
+	for(int i = count; --i >= 0; order[i] = i);
+	IndexSort2(rect, order, l.item, &RectLess);
+	for(int i = 0, n = cursor.GetCount(); i < n; ++i) {
+		int index = FindIndex(order, cursor[i]);
+		if(index >= 0)
+			cursor[i] = index;
+	}
+	ReloadItems();
+}
+
 void LayDes::Flush()
 {
 	currentlayout = -1;
diff -ruN uppsrc/ide/LayDes/LayDes.h uppsrc/ide/LayDes/LayDes.h
--- uppsrc/ide/LayDes/LayDes.h	2013-05-25 23:14:35 +0400
+++ uppsrc/ide/LayDes/LayDes.h	2013-08-14 01:22:04 +0400
@@ -384,6 +384,7 @@
 	void        Duplicate();
 	void        MoveUp();
 	void        MoveDown();
+	void        SortItems();
 	void        SelectAll();
 
 	void        Matrix();
diff -ruN uppsrc/ide/LayDes/laywin.cpp uppsrc/ide/LayDes/laywin.cpp
--- uppsrc/ide/LayDes/laywin.cpp	2012-09-21 20:56:42 +0400
+++ uppsrc/ide/LayDes/laywin.cpp	2013-08-20 02:14:41 +0400
@@ -48,6 +48,8 @@
 	bool iscursor = currentlayout >= 0 && cursor.GetCount();
 	bar.Add(iscursor, AK_MOVEUP, LayImg::MoveUp(), THISBACK(MoveUp));
 	bar.Add(iscursor, AK_MOVEDOWN, LayImg::MoveDown(), THISBACK(MoveDown));
+	bar.Separator();
+	bar.Add(item.GetCount() >= 2, "Sort by position", THISBACK(SortItems));
 }
 
 void LayDes::AlignBar(Bar& bar)
